/** @file cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.4
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef CMDLINE_H
#define CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define CMDLINE_PARSER_PACKAGE "RNASurface"
#endif

#ifndef CMDLINE_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#define CMDLINE_PARSER_PACKAGE_NAME "RNASurface"
#endif

#ifndef CMDLINE_PARSER_VERSION
/** @brief the program version */
#define CMDLINE_PARSER_VERSION "1.0"
#endif

/** @brief Where the command line options are stored */
struct gengetopt_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  char * input_arg;	/**< @brief Input file with sequence in fasta-format.  */
  char * input_orig;	/**< @brief Input file with sequence in fasta-format original value given at command line.  */
  const char *input_help; /**< @brief Input file with sequence in fasta-format help description.  */
  char * output_arg;	/**< @brief Output file with locally optimal structures in bed-format.  */
  char * output_orig;	/**< @brief Output file with locally optimal structures in bed-format original value given at command line.  */
  const char *output_help; /**< @brief Output file with locally optimal structures in bed-format help description.  */
  int diframe_arg;	/**< @brief Dinucleotide frame.  */
  char * diframe_orig;	/**< @brief Dinucleotide frame original value given at command line.  */
  const char *diframe_help; /**< @brief Dinucleotide frame help description.  */
  int winmax_arg;	/**< @brief Maximum window size.  */
  char * winmax_orig;	/**< @brief Maximum window size original value given at command line.  */
  const char *winmax_help; /**< @brief Maximum window size help description.  */
  int winmin_arg;	/**< @brief Minimum window size, more than 10nt.  */
  char * winmin_orig;	/**< @brief Minimum window size, more than 10nt original value given at command line.  */
  const char *winmin_help; /**< @brief Minimum window size, more than 10nt help description.  */
  double z_arg;	/**< @brief Z-score threshold.  */
  char * z_orig;	/**< @brief Z-score threshold original value given at command line.  */
  const char *z_help; /**< @brief Z-score threshold help description.  */
  int smooth_arg;	/**< @brief Smooth parameter.  */
  char * smooth_orig;	/**< @brief Smooth parameter original value given at command line.  */
  const char *smooth_help; /**< @brief Smooth parameter help description.  */
  int structured_flag;	/**< @brief search for locally optimal structured segments (default=on).  */
  const char *structured_help; /**< @brief search for locally optimal structured segments help description.  */
  int accessible_flag;	/**< @brief search for locally optimal sites of accessibility (default=off).  */
  const char *accessible_help; /**< @brief search for locally optimal sites of accessibility help description.  */
  int locopt_arg;	/**< @brief LocOpt parameter.  */
  char * locopt_orig;	/**< @brief LocOpt parameter original value given at command line.  */
  const char *locopt_help; /**< @brief LocOpt parameter help description.  */
  char * mapfile_arg;	/**< @brief Heatmap file.  */
  char * mapfile_orig;	/**< @brief Heatmap file original value given at command line.  */
  const char *mapfile_help; /**< @brief Heatmap file help description.  */
  char * signfile_arg;	/**< @brief File with values of significance.  */
  char * signfile_orig;	/**< @brief File with values of significance original value given at command line.  */
  const char *signfile_help; /**< @brief File with values of significance help description.  */
  char * densfile_arg;	/**< @brief File with values of optimal structures.  */
  char * densfile_orig;	/**< @brief File with values of optimal structures original value given at command line.  */
  const char *densfile_help; /**< @brief File with values of optimal structures help description.  */
  int densframe_arg;	/**< @brief Averaging frame for density file (densfile).  */
  char * densframe_orig;	/**< @brief Averaging frame for density file (densfile) original value given at command line.  */
  const char *densframe_help; /**< @brief Averaging frame for density file (densfile) help description.  */
  int v_flag;	/**< @brief print process state information (default=off).  */
  const char *v_help; /**< @brief print process state information help description.  */
  char * vtimefile_arg;	/**< @brief File with process state information.  */
  char * vtimefile_orig;	/**< @brief File with process state information original value given at command line.  */
  const char *vtimefile_help; /**< @brief File with process state information help description.  */
  int vstep_arg;	/**< @brief Step (in nucleotides) to output process state information.  */
  char * vstep_orig;	/**< @brief Step (in nucleotides) to output process state information original value given at command line.  */
  const char *vstep_help; /**< @brief Step (in nucleotides) to output process state information help description.  */
  char * chr_arg;	/**< @brief chromosome name.  */
  char * chr_orig;	/**< @brief chromosome name original value given at command line.  */
  const char *chr_help; /**< @brief chromosome name help description.  */
  char * outpar_arg;	/**< @brief file with parameters.  */
  char * outpar_orig;	/**< @brief file with parameters original value given at command line.  */
  const char *outpar_help; /**< @brief file with parameters help description.  */
  char * paired_arg;	/**< @brief file with experimental paired probability/density.  */
  char * paired_orig;	/**< @brief file with experimental paired probability/density original value given at command line.  */
  const char *paired_help; /**< @brief file with experimental paired probability/density help description.  */
  char * unpaired_arg;	/**< @brief file with experimental unpaired probability/density.  */
  char * unpaired_orig;	/**< @brief file with experimental unpaired probability/density original value given at command line.  */
  const char *unpaired_help; /**< @brief file with experimental unpaired probability/density help description.  */
  char * reactivity_arg;	/**< @brief file with shape reactivity.  */
  char * reactivity_orig;	/**< @brief file with shape reactivity original value given at command line.  */
  const char *reactivity_help; /**< @brief file with shape reactivity help description.  */
  double weight_arg;	/**< @brief weight of informational contribution to energy, default weight=RT.  */
  char * weight_orig;	/**< @brief weight of informational contribution to energy, default weight=RT original value given at command line.  */
  const char *weight_help; /**< @brief weight of informational contribution to energy, default weight=RT help description.  */
  char * paramin_arg;	/**< @brief input file with energy expectation and standard deviation for different lengths.  */
  char * paramin_orig;	/**< @brief input file with energy expectation and standard deviation for different lengths original value given at command line.  */
  const char *paramin_help; /**< @brief input file with energy expectation and standard deviation for different lengths help description.  */
  int unmap_flag;	/**< @brief cancel procedure of mapping of MFE to derived probing energy in order to obtain unbaised Z-score (default=on).  */
  const char *unmap_help; /**< @brief cancel procedure of mapping of MFE to derived probing energy in order to obtain unbaised Z-score help description.  */
  char * paramreg_arg;	/**< @brief input file with parameters of regression of energy and coverage.  */
  char * paramreg_orig;	/**< @brief input file with parameters of regression of energy and coverage original value given at command line.  */
  const char *paramreg_help; /**< @brief input file with parameters of regression of energy and coverage help description.  */
  int sample_size_arg;	/**< @brief size of sample to provide mapping of MFE to derived probing energy, default 200.  */
  char * sample_size_orig;	/**< @brief size of sample to provide mapping of MFE to derived probing energy, default 200 original value given at command line.  */
  const char *sample_size_help; /**< @brief size of sample to provide mapping of MFE to derived probing energy, default 200 help description.  */
  double reg_param_arg;	/**< @brief parameter of sampling to map MFE to derived probing energy, default 0.01.  */
  char * reg_param_orig;	/**< @brief parameter of sampling to map MFE to derived probing energy, default 0.01 original value given at command line.  */
  const char *reg_param_help; /**< @brief parameter of sampling to map MFE to derived probing energy, default 0.01 help description.  */
  char * out_reg_arg;	/**< @brief filename to print regression parameters of linear regression of derived probing energy to MFE.  */
  char * out_reg_orig;	/**< @brief filename to print regression parameters of linear regression of derived probing energy to MFE original value given at command line.  */
  const char *out_reg_help; /**< @brief filename to print regression parameters of linear regression of derived probing energy to MFE help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int input_given ;	/**< @brief Whether input was given.  */
  unsigned int output_given ;	/**< @brief Whether output was given.  */
  unsigned int diframe_given ;	/**< @brief Whether diframe was given.  */
  unsigned int winmax_given ;	/**< @brief Whether winmax was given.  */
  unsigned int winmin_given ;	/**< @brief Whether winmin was given.  */
  unsigned int z_given ;	/**< @brief Whether z was given.  */
  unsigned int smooth_given ;	/**< @brief Whether smooth was given.  */
  unsigned int structured_given ;	/**< @brief Whether structured was given.  */
  unsigned int accessible_given ;	/**< @brief Whether accessible was given.  */
  unsigned int locopt_given ;	/**< @brief Whether locopt was given.  */
  unsigned int mapfile_given ;	/**< @brief Whether mapfile was given.  */
  unsigned int signfile_given ;	/**< @brief Whether signfile was given.  */
  unsigned int densfile_given ;	/**< @brief Whether densfile was given.  */
  unsigned int densframe_given ;	/**< @brief Whether densframe was given.  */
  unsigned int v_given ;	/**< @brief Whether v was given.  */
  unsigned int vtimefile_given ;	/**< @brief Whether vtimefile was given.  */
  unsigned int vstep_given ;	/**< @brief Whether vstep was given.  */
  unsigned int chr_given ;	/**< @brief Whether chr was given.  */
  unsigned int outpar_given ;	/**< @brief Whether outpar was given.  */
  unsigned int paired_given ;	/**< @brief Whether paired was given.  */
  unsigned int unpaired_given ;	/**< @brief Whether unpaired was given.  */
  unsigned int reactivity_given ;	/**< @brief Whether reactivity was given.  */
  unsigned int weight_given ;	/**< @brief Whether weight was given.  */
  unsigned int paramin_given ;	/**< @brief Whether paramin was given.  */
  unsigned int unmap_given ;	/**< @brief Whether unmap was given.  */
  unsigned int paramreg_given ;	/**< @brief Whether paramreg was given.  */
  unsigned int sample_size_given ;	/**< @brief Whether sample_size was given.  */
  unsigned int reg_param_given ;	/**< @brief Whether reg_param was given.  */
  unsigned int out_reg_given ;	/**< @brief Whether out_reg was given.  */

} ;

/** @brief The additional parameters to pass to parser functions */
struct cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gengetopt_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gengetopt_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *gengetopt_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gengetopt_args_info_usage;
/** @brief all the lines making the help output */
extern const char *gengetopt_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser (int argc, char **argv,
  struct gengetopt_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_ext() instead
 */
int cmdline_parser2 (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_ext (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  struct cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_dump(FILE *outfile,
  struct gengetopt_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

/**
 * Print the help
 */
void cmdline_parser_print_help(void);
/**
 * Print the version
 */
void cmdline_parser_print_version(void);

/**
 * Initializes all the fields a cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void cmdline_parser_params_init(struct cmdline_parser_params *params);

/**
 * Allocates dynamically a cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized cmdline_parser_params structure
 */
struct cmdline_parser_params *cmdline_parser_params_create(void);

/**
 * Initializes the passed gengetopt_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void cmdline_parser_init (struct gengetopt_args_info *args_info);
/**
 * Deallocates the string fields of the gengetopt_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void cmdline_parser_free (struct gengetopt_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* CMDLINE_H */
