/*
coef.h
Copyright (C) yyyy Ruslan Soldatov

* RNASurface: fast and accurate detection of locally optimal potentially structured RNA segments

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Contact e-mail: ruslansoldatov@gmail.com
*/
#define control_points 11
#define length_low_bound 10

/*
		Information about approximation for control length
		length - length of sequences
		mean,sd - arrays of quadratic approximations coefficients
*/
struct coefficients{
	int length;
	double mean[27][257];
	double sd[27][257];
} ;

int lower_ind;/* define index of lower control length */

int upper_ind;/* define index of upper control length */

struct coefficients coef[control_points];

void read_coefficients(char* execFile); 

double meanEst(int length,double mean[]);

double sdEst(int length,double sd[]);

