/** @file cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.4
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef CMDLINE_H
#define CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define CMDLINE_PARSER_PACKAGE "estimation"
#endif

#ifndef CMDLINE_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#define CMDLINE_PARSER_PACKAGE_NAME "estimation"
#endif

#ifndef CMDLINE_PARSER_VERSION
/** @brief the program version */
#define CMDLINE_PARSER_VERSION "1.0"
#endif

/** @brief Where the command line options are stored */
struct gengetopt_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  char * input_arg;	/**< @brief Input file with sequence in fasta-format.  */
  char * input_orig;	/**< @brief Input file with sequence in fasta-format original value given at command line.  */
  const char *input_help; /**< @brief Input file with sequence in fasta-format help description.  */
  char * paired_arg;	/**< @brief Input file with paired probabilities.  */
  char * paired_orig;	/**< @brief Input file with paired probabilities original value given at command line.  */
  const char *paired_help; /**< @brief Input file with paired probabilities help description.  */
  char * unpaired_arg;	/**< @brief Input file with unpaired probabilities.  */
  char * unpaired_orig;	/**< @brief Input file with unpaired probabilities original value given at command line.  */
  const char *unpaired_help; /**< @brief Input file with unpaired probabilities help description.  */
  char * output_arg;	/**< @brief Output file with estimated parameters.  */
  char * output_orig;	/**< @brief Output file with estimated parameters original value given at command line.  */
  const char *output_help; /**< @brief Output file with estimated parameters help description.  */
  int winmax_arg;	/**< @brief Maximum length of sequence to estimate parameters, by default 300.  */
  char * winmax_orig;	/**< @brief Maximum length of sequence to estimate parameters, by default 300 original value given at command line.  */
  const char *winmax_help; /**< @brief Maximum length of sequence to estimate parameters, by default 300 help description.  */
  int winmin_arg;	/**< @brief Minimum length of sequence to estimate parameters, by default 10.  */
  char * winmin_orig;	/**< @brief Minimum length of sequence to estimate parameters, by default 10 original value given at command line.  */
  const char *winmin_help; /**< @brief Minimum length of sequence to estimate parameters, by default 10 help description.  */
  int di_flag;	/**< @brief Flag, whether to preserve dinucleotide composition, by default only nucleotide composition is preserved (default=off).  */
  const char *di_help; /**< @brief Flag, whether to preserve dinucleotide composition, by default only nucleotide composition is preserved help description.  */
  int markov_flag;	/**< @brief Flag, whether to simulate markov model, by default permutation is exact (default=off).  */
  const char *markov_help; /**< @brief Flag, whether to simulate markov model, by default permutation is exact help description.  */
  double intersect_arg;	/**< @brief Intersect between consequtive windows relative to window length, from 0 (non overlaping) to 1 (all windows is considered). By default = 0.  */
  char * intersect_orig;	/**< @brief Intersect between consequtive windows relative to window length, from 0 (non overlaping) to 1 (all windows is considered). By default = 0 original value given at command line.  */
  const char *intersect_help; /**< @brief Intersect between consequtive windows relative to window length, from 0 (non overlaping) to 1 (all windows is considered). By default = 0 help description.  */
  int size_arg;	/**< @brief Size of sample to estimate parameters, by default 100.  */
  char * size_orig;	/**< @brief Size of sample to estimate parameters, by default 100 original value given at command line.  */
  const char *size_help; /**< @brief Size of sample to estimate parameters, by default 100 help description.  */
  int no_transform_flag;	/**< @brief Flag, not to transform shuffled data to match initial data distribution (default=off).  */
  const char *no_transform_help; /**< @brief Flag, not to transform shuffled data to match initial data distribution help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int input_given ;	/**< @brief Whether input was given.  */
  unsigned int paired_given ;	/**< @brief Whether paired was given.  */
  unsigned int unpaired_given ;	/**< @brief Whether unpaired was given.  */
  unsigned int output_given ;	/**< @brief Whether output was given.  */
  unsigned int winmax_given ;	/**< @brief Whether winmax was given.  */
  unsigned int winmin_given ;	/**< @brief Whether winmin was given.  */
  unsigned int di_given ;	/**< @brief Whether di was given.  */
  unsigned int markov_given ;	/**< @brief Whether markov was given.  */
  unsigned int intersect_given ;	/**< @brief Whether intersect was given.  */
  unsigned int size_given ;	/**< @brief Whether size was given.  */
  unsigned int no_transform_given ;	/**< @brief Whether no_transform was given.  */

} ;

/** @brief The additional parameters to pass to parser functions */
struct cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gengetopt_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gengetopt_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *gengetopt_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gengetopt_args_info_usage;
/** @brief all the lines making the help output */
extern const char *gengetopt_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser (int argc, char **argv,
  struct gengetopt_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_ext() instead
 */
int cmdline_parser2 (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_ext (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  struct cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_dump(FILE *outfile,
  struct gengetopt_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

/**
 * Print the help
 */
void cmdline_parser_print_help(void);
/**
 * Print the version
 */
void cmdline_parser_print_version(void);

/**
 * Initializes all the fields a cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void cmdline_parser_params_init(struct cmdline_parser_params *params);

/**
 * Allocates dynamically a cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized cmdline_parser_params structure
 */
struct cmdline_parser_params *cmdline_parser_params_create(void);

/**
 * Initializes the passed gengetopt_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void cmdline_parser_init (struct gengetopt_args_info *args_info);
/**
 * Deallocates the string fields of the gengetopt_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void cmdline_parser_free (struct gengetopt_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* CMDLINE_H */
