/** @file cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.4
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef CMDLINE_H
#define CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define CMDLINE_PARSER_PACKAGE "inferStructure"
#endif

#ifndef CMDLINE_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#define CMDLINE_PARSER_PACKAGE_NAME "inferStructure"
#endif

#ifndef CMDLINE_PARSER_VERSION
/** @brief the program version */
#define CMDLINE_PARSER_VERSION "1.0"
#endif

/** @brief Where the command line options are stored */
struct gengetopt_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  char * input_arg;	/**< @brief Input file with sequence in fasta-format.  */
  char * input_orig;	/**< @brief Input file with sequence in fasta-format original value given at command line.  */
  const char *input_help; /**< @brief Input file with sequence in fasta-format help description.  */
  char * output_arg;	/**< @brief Output file with RNA secondary structure and minimum free energy.  */
  char * output_orig;	/**< @brief Output file with RNA secondary structure and minimum free energy original value given at command line.  */
  const char *output_help; /**< @brief Output file with RNA secondary structure and minimum free energy help description.  */
  int uppersize_arg;	/**< @brief Upper bound of file size.  */
  char * uppersize_orig;	/**< @brief Upper bound of file size original value given at command line.  */
  const char *uppersize_help; /**< @brief Upper bound of file size help description.  */
  int traceback_flag;	/**< @brief output secondary structure in dot bracket format (default=on).  */
  const char *traceback_help; /**< @brief output secondary structure in dot bracket format help description.  */
  int winsize_arg;	/**< @brief size of window.  */
  char * winsize_orig;	/**< @brief size of window original value given at command line.  */
  const char *winsize_help; /**< @brief size of window help description.  */
  char * paired_arg;	/**< @brief file with experimental paired probability/density.  */
  char * paired_orig;	/**< @brief file with experimental paired probability/density original value given at command line.  */
  const char *paired_help; /**< @brief file with experimental paired probability/density help description.  */
  char * unpaired_arg;	/**< @brief file with experimental unpaired probability/density.  */
  char * unpaired_orig;	/**< @brief file with experimental unpaired probability/density original value given at command line.  */
  const char *unpaired_help; /**< @brief file with experimental unpaired probability/density help description.  */
  char * reactivity_arg;	/**< @brief file with shape reactivity.  */
  char * reactivity_orig;	/**< @brief file with shape reactivity original value given at command line.  */
  const char *reactivity_help; /**< @brief file with shape reactivity help description.  */
  double weight_arg;	/**< @brief weight of informational contribution to energy, default weight=RT.  */
  char * weight_orig;	/**< @brief weight of informational contribution to energy, default weight=RT original value given at command line.  */
  const char *weight_help; /**< @brief weight of informational contribution to energy, default weight=RT help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int input_given ;	/**< @brief Whether input was given.  */
  unsigned int output_given ;	/**< @brief Whether output was given.  */
  unsigned int uppersize_given ;	/**< @brief Whether uppersize was given.  */
  unsigned int traceback_given ;	/**< @brief Whether traceback was given.  */
  unsigned int winsize_given ;	/**< @brief Whether winsize was given.  */
  unsigned int paired_given ;	/**< @brief Whether paired was given.  */
  unsigned int unpaired_given ;	/**< @brief Whether unpaired was given.  */
  unsigned int reactivity_given ;	/**< @brief Whether reactivity was given.  */
  unsigned int weight_given ;	/**< @brief Whether weight was given.  */

} ;

/** @brief The additional parameters to pass to parser functions */
struct cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gengetopt_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gengetopt_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *gengetopt_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gengetopt_args_info_usage;
/** @brief all the lines making the help output */
extern const char *gengetopt_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser (int argc, char **argv,
  struct gengetopt_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_ext() instead
 */
int cmdline_parser2 (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_ext (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  struct cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_dump(FILE *outfile,
  struct gengetopt_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

/**
 * Print the help
 */
void cmdline_parser_print_help(void);
/**
 * Print the version
 */
void cmdline_parser_print_version(void);

/**
 * Initializes all the fields a cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void cmdline_parser_params_init(struct cmdline_parser_params *params);

/**
 * Allocates dynamically a cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized cmdline_parser_params structure
 */
struct cmdline_parser_params *cmdline_parser_params_create(void);

/**
 * Initializes the passed gengetopt_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void cmdline_parser_init (struct gengetopt_args_info *args_info);
/**
 * Deallocates the string fields of the gengetopt_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void cmdline_parser_free (struct gengetopt_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* CMDLINE_H */
