/*
parseConfig.c
Copyright (C) yyyy Ruslan Soldatov

* RNASurface: fast and accurate detection of locally optimal potentially structured RNA segments

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Contact e-mail: ruslansoldatov@gmail.com
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "rnaSurface.h"

/* 
	Define path to program directory
*/

/*char**/void pathHead(char* pathExec,char* head)
{
	char *root0 ,*root;
	int len0,len;
	
	len0=strrchr(pathExec,DIS)-pathExec;
	root0=(char*)malloc( (len0+1)*sizeof(char)  );
	strncpy(root0,pathExec, len0 );
	root0[len0]='\0';
	
	len=strrchr(root0,DIS)-root0;
	root=(char*)malloc( (len+1)*sizeof(char)  );
	strncpy(root,root0, len );
	root[len]='\0';
	strcpy(head,root);

	free(root0);
	free(root);
}


/*
	parse configuration file
*/
void parseConfig(char* execFile,struct InputParam* configParam)
{
	char *root0,*root,configFile[1000];
	int len0,len,len_conf;
	
	len0=strrchr(execFile,DIS)-execFile;
	root0=(char*)malloc( (len0+1)*sizeof(char)  );
	strncpy(root0,execFile, len0 );
	root0[len0]='\0';
	
	len=strrchr(root0,DIS)-root0;
	root=(char*)malloc( (len+1)*sizeof(char)  );
	strncpy(root,root0, len );
	root[len]='\0';
	
	sprintf(configFile,"%s%crnaSurface.cfg",root0,DIS);
	
	FILE* f=fopen(configFile,"r");
	if ( f != NULL )
	{
		char option[100],parameter[100];
		while ( feof(f) == 0 )
		{	
			fscanf(f,"%s\t%s",option,parameter);
			if ( strcmp(option,"inFile") == 0) strcpy((*configParam).inFile,parameter);
			else if ( strcmp(option,"outFile") == 0 ) sprintf((*configParam).outFile,"%s%c%s",root,DIS,parameter);
			else if ( strcmp(option,"diWindow") == 0 ) (*configParam).diWindow=atoi(parameter);
			else if ( strcmp(option,"winMax") == 0 ) (*configParam).winMax=atoi(parameter);
			else if ( strcmp(option,"winMin") == 0 ) (*configParam).winMin=atoi(parameter);
			else if ( strcmp(option,"z") == 0 ) (*configParam).z=atof(parameter);
			else if ( strcmp(option,"smooth") == 0 ) (*configParam).smooth=atoi(parameter);
			else if ( strcmp(option,"locOpt") == 0 ) (*configParam).locOpt=atoi(parameter);
			else if ( strcmp(option,"print_map") == 0 ) (*configParam).print_map=atoi(parameter);
			else if ( strcmp(option,"print_minScore") == 0 ) (*configParam).print_sign=atoi(parameter);
			else if ( strcmp(option,"mapFile") == 0 ) sprintf((*configParam).mapFile,"%s%c%s",root,DIS,parameter);
			else if ( strcmp(option,"signFile") == 0 ) {sprintf((*configParam).signFile,"%s%c%s",root,DIS,parameter);}
			else if ( strcmp(option,"densFile") == 0 ) {sprintf((*configParam).densFile,"%s%c%s",root,DIS,parameter);}
			else if ( strcmp(option,"densFrame") == 0 ) (*configParam).densFrame=atoi(parameter);
			else if ( strcmp(option,"v") == 0 ) (*configParam).v=atoi(parameter);
			else if ( strcmp(option,"vstep") == 0 ) (*configParam).vstep=atoi(parameter);
			else if ( strcmp(option,"chr") == 0 ) strcpy((*configParam).chr,parameter);
			else fprintf(stderr,"Wrong configuration file");
		}
	}else{
		fprintf(stderr,"Error in opening configuration file!\n");
		exit(1);
	}
	free(root0);
	free(root);
	fclose(f);
}