/*
rnaSurface.h
Copyright (C) yyyy Ruslan Soldatov

* RNASurface: fast and accurate detection of locally optimal potentially structured RNA segments

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Contact e-mail: ruslansoldatov@gmail.com
*/
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <limits.h>
#include <string.h>


#ifdef WIN32
#define PLATFORM "win"
#define PATH_LEN MAX_PATH
#define DIS '\\'
#include<windows.h>
#else
#define PLATFORM "another"
#define PATH_LEN PATH_MAX
#define DIS '/'
#include <sys/param.h>
#endif

/* from fileproc.c */
void fileConverter(char* chr,FILE* inputBin,FILE* outputText,int option);
/* from cumulativeLocOpt.c */
void densityLocOpt(FILE* in,char* out,int seq_length,int win);

double lambda;
void defLam(int n);
double calculateLambda(int n);


void defStatWeight(int n);
float* statWeight; 

struct InputParam
{
	char inFile[255];
	char outFile[255];
	int diWindow;
	int winMax;
	int winMin;
	double z;
	int	smooth;
	int locOpt;
	int print_map;
	int print_sign;
	int print_dens;
	char mapFile[255];
	char signFile[255];
	char densFile[255];
	int densFrame;
	int v;
	char vtimeFile[255];
	int vstep;
	char chr[255];
};

void parseConfig(char* execFile,struct InputParam* configParam);