/*
shuffle.c
Copyright (C) yyyy Ruslan Soldatov

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Contact e-mail: ruslansoldatov@gmail.com
*/
#include "shuffle.h"
#include "shuffleFunc.h"
#include "methods.h"
#include "transformation.h"

struct shuffleSeq shuffle(char* seq, double* data,double* data1, int di, int markov){

	struct shuffleSeq tmp;

	if (di==0 && markov==0)
		tmp = shuffleExact(seq,data,data1);
	else if (di==0 && markov==1)
		tmp = shuffleMarkov(seq,data,data1);
	else if (di==1 && markov==0)
		tmp = shuffleDiExact(seq,data,data1);
	else if (di==1 && markov==1)
		tmp = shuffleDiMarkov(seq,data,data1);
	else{
		if (di!=0 && di!=1)
			fprintf(stderr, "Wrong input parameter di");
		else if (markov!=0 && markov!=1)
			fprintf(stderr, "Wrong input parameter markov");
	}
	if (qtransform==1){
		if (tmp.data_exists==1){
			transformation(data,tmp.data,strlen(seq));
		}
		if (tmp.data1_exists==1){
			transformation(data1,tmp.data1,strlen(seq));
		}
	}
	return tmp;
}

