/*
shuffleFunc.h
Copyright (C) yyyy Ruslan Soldatov

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Contact e-mail: ruslansoldatov@gmail.com
*/
#include <stdio.h>
#include <stdlib.h>

/*  structure to keep track data */
struct Data
{
	double** data;
	double** data1;
};

/* structrue to keep sequence and track data*/
struct Info
{
	int length;
	int content[4];
	int dicontent[4][4];
	struct Data data;
};

struct Info makeInfo(char* seq, double* data, double* data1);
struct Data makeData(char* seq, double* data, double* data1, int* content);

/* convert nucleotides to numbers (convert) and back (revert)
	A - 0
	T - 1
	G - 2
	C - 3
*/
int convert(char nt);
char revert(int n);

/* return permutation of numbers 0,1,..,n-1 */
int* permutation(int n);
void swap(int* array, int i, int j);
/* return random number from sample 0,1,..,n-1 with weights weight[0],..,weight[n-1] */
int rnd(int n, double* weight);
/* convert int array to double*/
double* int2double(int* array, int length);
int convert(char nt);